package com.example.backend;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.example.backend.categories.model.CategorieEntity;
import com.example.backend.categories.service.CategorieService;
import com.example.backend.users.model.UserEntity;
import com.example.backend.users.model.UserRole;
import com.example.backend.users.service.UserService;

// create lab 2

@SpringBootApplication
public class BackendApplication implements CommandLineRunner {

	private final Logger _logger = LoggerFactory.getLogger(BackendApplication.class);
	private final UserService userService;
	private final CategorieService categorieService;

	public BackendApplication(UserService userService, CategorieService categorieService) {
		this.userService = userService;
		this.categorieService = categorieService;
	}

	public static void main(String[] args) {
		SpringApplication.run(BackendApplication.class, args);
	}

	@Override
	public void run(String... args) throws Exception {
		final var admin = new UserEntity(null, "elena", "1234");
		final var vasya = new UserEntity(null, "vasya", "1234");

		final var u1 = new UserEntity(null, "1", "1234");
		final var u2 = new UserEntity(null, "2", "1234");
		final var u3 = new UserEntity(null, "3", "1234");
		final var u4 = new UserEntity(null, "4", "1234");
		final var u5 = new UserEntity(null, "5", "1234");
		final var u6 = new UserEntity(null, "6", "1234");
		final var u7 = new UserEntity(null, "7", "1234");

		final var cat1 = new CategorieEntity(null, "Драма", null);

		admin.setRole(UserRole.ADMIN);
		vasya.setRole(UserRole.USER);

		u1.setRole(UserRole.USER);
		u2.setRole(UserRole.USER);
		u3.setRole(UserRole.USER);
		u4.setRole(UserRole.USER);
		u5.setRole(UserRole.USER);
		u6.setRole(UserRole.USER);
		u7.setRole(UserRole.USER);

		userService.create(admin);
		userService.create(vasya);
		userService.create(u1);
		userService.create(u2);
		userService.create(u3);
		userService.create(u4);
		userService.create(u5);
		userService.create(u6);
		userService.create(u7);

		categorieService.create(cat1);

		_logger.info("Admin user added");
	}

}
